<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE xsl:stylesheet [ 
  <!ENTITY nbsp "&#160;"> 
  <!ENTITY mdash "&#8212;">
]>

<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1"
   xmlns:saxon="http://icl.com/saxon"
   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
   xmlns="http://www.w3.org/2000/svg"
   xmlns:ink-r="org.inkscape.xslt.files"
   xmlns:ink="http://www.inkscape.org/namespaces/xslt"
   xmlns:xlink="http://www.w3.org/1999/xlink"
   xmlns:string="http://www.jclark.com/xt/java/java.lang.String"
   exclude-result-prefixes="saxon ink-r xsl"
   extension-element-prefixes="saxon ink-r ink"
>

<xsl:output method="xml" encoding="utf-8" indent="no" saxon:omit-meta-tag="yes"/>

<xsl:param name="ill-path"/>
<xsl:param name="ink-path"/>
<xsl:param name="language">en</xsl:param>

<xsl:variable name="font-sans">Sans</xsl:variable>
<xsl:variable name="font-serif">Serif</xsl:variable>

<xsl:variable name="normal-style">font-size:8;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:133.00000%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;font-family:Serif;-inkscape-font-specification:Serif</xsl:variable>

<xsl:variable name="parskip">10</xsl:variable>
<xsl:variable name="abstract-parskip">6</xsl:variable>
<xsl:variable name="imageskip-before">8</xsl:variable>
<xsl:variable name="imageskip-after">12</xsl:variable>

<xsl:variable name="column-width">288</xsl:variable>
<xsl:variable name="abstract-column-width">264</xsl:variable>
<xsl:variable name="item-column-width">258</xsl:variable>

<xsl:variable name="left-margin">10</xsl:variable>
<xsl:variable name="abstract-left-margin">35</xsl:variable>
<xsl:variable name="item-left-margin">20</xsl:variable>

<xsl:variable name="head-fs">8</xsl:variable>
<xsl:variable name="head2-fs">7.5</xsl:variable>
<xsl:variable name="abstract-fs">7.2</xsl:variable>

<xsl:variable name="header-filename">
	<xsl:choose>
		<xsl:when test="$language = 'en'">_tutorial-header.svg</xsl:when>
		<xsl:otherwise>
			<xsl:choose>
				<xsl:when test="ink-r:exists(concat('_tutorial-header.', $language, '.svg'))"><xsl:value-of select="concat('_tutorial-header.', $language, '.svg')"/></xsl:when>
				<xsl:otherwise>_tutorial-header.svg</xsl:otherwise>
			</xsl:choose>
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="footer-filename">
	<xsl:choose>
		<xsl:when test="$language = 'en'">_tutorial-footer.svg</xsl:when>
		<xsl:otherwise>
			<xsl:choose>
				<xsl:when test="ink-r:exists(concat('_tutorial-footer.', $language, '.svg'))"><xsl:value-of select="concat('_tutorial-footer.', $language, '.svg')"/></xsl:when>
				<xsl:otherwise>_tutorial-footer.svg</xsl:otherwise>
			</xsl:choose>
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="y" saxon:assignable="yes">36</xsl:variable> <!--spusk-->

<!-- page skeleton -->
<xsl:template match="/">
<xsl:comment> DO NOT EDIT THIS FILE. It is produced automatically from a DocBook source (*.xml) by tutorial-svg.xsl. </xsl:comment>
<svg
   xmlns:xml="http://www.w3.org/XML/1998/namespace"
   xmlns:dc="http://purl.org/dc/elements/1.1/"
   xmlns:cc="http://web.resource.org/cc/"
   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
   xmlns:svg="http://www.w3.org/2000/svg"
   xmlns="http://www.w3.org/2000/svg"
   xmlns:xlink="http://www.w3.org/1999/xlink"
   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
   id="svg1"
   version="1.1"
   sodipodi:version="0.32"
   inkscape:version="0.48"
   width="256pt"
   height="3170.0000pt"
   sodipodi:docname="tutorial-basic.svg">
  <sodipodi:namedview
     id="base"
     inkscape:zoom="2.0000000"
     inkscape:cx="160.00000"
     inkscape:cy="3864.0000"
     inkscape:window-width="780"
     inkscape:window-height="580"
     inkscape:window-x="0"
     inkscape:window-y="0"
     showborder="false"
     showguides="true"
     snaptoguides="true"/>

<!-- header -->
<xsl:for-each select="document($header-filename)/*/*[name() != 'sodipodi:namedview']"> 
 <xsl:copy-of select="."/>
</xsl:for-each>

<!-- title -->
    <text
       style="font-family:{$font-sans};stroke:none;fill-opacity:1.0000000;fill:#ffffff;text-anchor:start;writing-mode:lr-tb;font-stretch:normal;font-weight:normal;font-variant:normal;font-style:normal;font-size:7.0000000"
       x="176.24451"
       y="18.25828"
       id="text1920"
       transform="scale(1.130730,1.130730)"><tspan
         id="tspan1668"
         dx="0 -0.57057059 0 0 0 0 0"
         style="letter-spacing:2.1813099;fill:#ffffff;fill-opacity:1.0000000">::<xsl:value-of select="string:toUpperCase(book/chapter/title)"/></tspan></text>

<!-- body content -->
<xsl:apply-templates/>

<!-- footer -->
<g transform="translate(0, {$y})">
<xsl:for-each select="document($footer-filename)/*/*[name() != 'sodipodi:namedview']"> 
 <xsl:copy-of select="."/>
</xsl:for-each>
</g>

</svg>
</xsl:template>

<xsl:template match="chapter/title"/>

<xsl:template match="author">
<xsl:comment>Author: <xsl:value-of select="."/></xsl:comment>
</xsl:template>

<saxon:function name="ink:strip-leading-whitespace">
  <xsl:param name="string"/>
<saxon:return>
      <xsl:choose>
        <xsl:when test="starts-with($string, ' ') or starts-with($string, '&#xD;') or starts-with($string, '&#xA;')">
          <xsl:value-of select="ink:strip-leading-whitespace(substring($string, 2, string-length(.)))"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$string"/>
        </xsl:otherwise>
      </xsl:choose>  
</saxon:return>
</saxon:function>


<xsl:template match="para/text()[not(preceding-sibling::*)]">
  <xsl:value-of select="ink:strip-leading-whitespace(.)"/>
</xsl:template>


<xsl:template match="sect1/para|sect2/para" mode="height">
  <xsl:document href="para-query.svg" encoding="utf-8" method="xml" omit-xml-declaration="yes" indent="yes">
    <svg width="1600px" height="400px">
      <rect id="rectID" width="{$column-width}" height="1000px" x="{$left-margin}" y="0px" style="fill:none"/>
    <flowRoot
       id="flowRootID" style="{$normal-style}">
      <flowRegion>
        <use
           xlink:href="#rectID"
           y="0"
           x="0" />
      </flowRegion>
      <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
    </svg>
  </xsl:document>
<xsl:value-of select="ink-r:run(concat($ink-path, ' para-query.svg --query-height --query-id flowRootID'))"/>
</xsl:template>

<xsl:template match="listitem/para" mode="height">
  <xsl:document href="para-query.svg" encoding="utf-8" method="xml" omit-xml-declaration="yes" indent="yes">
    <svg width="1600px" height="400px">
      <rect id="rectID" width="{$item-column-width}" height="1000px" x="{$item-left-margin}" y="0px" style="fill:none"/>
    <flowRoot
       id="flowRootID" style="{$normal-style}">
      <flowRegion>
        <use
           xlink:href="#rectID"
           y="0"
           x="0" />
      </flowRegion>
      <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
    </svg>
  </xsl:document>
<xsl:value-of select="ink-r:run(concat($ink-path, ' para-query.svg --query-height --query-id flowRootID'))"/>
</xsl:template>


<xsl:template match="abstract/para" mode="height">
  <xsl:document href="para-query.svg" encoding="utf-8" method="xml" omit-xml-declaration="yes" indent="yes">
    <svg width="1600px" height="400px">
      <rect id="rectID" width="{$abstract-column-width}" height="1000px" x="{$abstract-left-margin}" y="0px" style="fill:none"/>
    <flowRoot
       id="flowRootID" style="font-size:{$abstract-fs};font-style:italic;font-weight:normal;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1.0000000;stroke:none;font-family:{$font-sans}">
      <flowRegion>
        <use
           xlink:href="#rectID"
           y="0"
           x="0" />
      </flowRegion>
      <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
    </svg>
  </xsl:document>
<xsl:value-of select="ink-r:run(concat($ink-path, ' para-query.svg --query-height --query-id flowRootID'))"/>
</xsl:template>

<xsl:template match="sect1/title">
    <text
       style="font-size:{$head-fs};font-style:normal;font-weight:bold;fill:#000000;fill-opacity:1.0000000;stroke:none;font-family:{$font-sans};text-anchor:start;writing-mode:lr"
       x="{$left-margin}"
       y="{$y + 1.6*$head-fs}"><tspan
         x="{$left-margin}"
         y="{$y + 1.6*$head-fs}"
         ><xsl:apply-templates/></tspan></text>
<saxon:assign name="y" select="$y + $head-fs + $parskip"/>
</xsl:template>

<xsl:template match="sect2/title">
    <text
       style="font-size:{$head2-fs};font-style:italic;font-weight:bold;fill:#000000;fill-opacity:1.0000000;stroke:none;font-family:{$font-sans};text-anchor:start;writing-mode:lr"
       x="{$left-margin}"
       y="{$y + 1.6*$head2-fs}"><tspan
         x="{$left-margin}"
         y="{$y + 1.6*$head2-fs}"
         ><xsl:apply-templates/></tspan></text>
<saxon:assign name="y" select="$y + $head2-fs + $parskip"/>
</xsl:template>

<xsl:template match="sect1/para|sect2/para">
    <rect id="{generate-id()}" width="{$column-width}" height="1000px" x="{$left-margin}" y="{$y}" style="display:none"/>
    <flowRoot
       style="{$normal-style}">
      <flowRegion>
        <use
           xlink:href="#{generate-id()}"
           y="0"
           x="0" />
      </flowRegion>
      <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
<xsl:variable name="current-h"><xsl:apply-templates select="." mode="height"/></xsl:variable>
<saxon:assign name="y" select="$y + $current-h + $parskip"/>
</xsl:template>

<xsl:template match="abstract/para">
    <rect id="{generate-id()}" width="{$abstract-column-width}" height="1000px" x="{$abstract-left-margin}" y="{$y}" style="display:none"/>
    <flowRoot
       style="font-size:{$abstract-fs};font-style:italic;font-weight:normal;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1.0000000;stroke:none;font-family:{$font-sans}">
      <flowRegion>
        <use
           xlink:href="#{generate-id()}"
           y="0"
           x="0" />
      </flowRegion>
      <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
<xsl:variable name="current-h"><xsl:apply-templates select="." mode="height"/></xsl:variable>
<saxon:assign name="y" select="$y + $current-h + $abstract-parskip"/>
</xsl:template>

<xsl:template match="listitem/para">
<circle cx="0" cy="0" r="2" transform="translate({$item-left-margin - 5}, {$y + 6})"/>
<rect id="{generate-id()}" width="{$item-column-width}" height="1000px" x="{$item-left-margin}" y="{$y}" style="display:none"/>
    <flowRoot style="{$normal-style}">
      <flowRegion>
        <use
           xlink:href="#{generate-id()}"
           y="0" x="0" />
      </flowRegion>
      <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
<xsl:variable name="current-h"><xsl:apply-templates select="." mode="height"/></xsl:variable>
<saxon:assign name="y" select="$y + $current-h + $parskip"/>
</xsl:template>


<xsl:template match="keycap">
<flowSpan style="font-weight:bold"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="command">
<flowSpan style="font-family:Sans"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="emphasis">
<flowSpan style="font-style:italic"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="firstterm">
<flowSpan style="font-style:italic"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="ulink">
<flowSpan style="font-weight:bold; font-family:Sans"><xsl:apply-templates/></flowSpan>
</xsl:template>



<saxon:function name="ink:prefixize">
  <xsl:param name="prefix"/>
  <xsl:param name="string"/>
  <saxon:return>
      <xsl:choose>
        <xsl:when test="contains($string, 'url(#')">
          <xsl:value-of select="concat(substring-before($string, 'url(#'), 'url(#', $prefix, ink:prefixize($prefix, substring-after($string, 'url(#')))"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$string"/>
        </xsl:otherwise>
      </xsl:choose>
  </saxon:return>
</saxon:function>

<xsl:template match="@*" mode="reid">
<xsl:param name="prefix"/>
<!--<xsl:message>prefix <xsl:value-of select="$prefix"/>, name <xsl:value-of select="name()"/></xsl:message>-->
<xsl:choose>
  <xsl:when test="name()='id'">
    <xsl:attribute name="{name()}">
      <xsl:value-of select="concat($prefix, .)"/>
    </xsl:attribute>
  </xsl:when>
  <xsl:when test="name()='xlink:href'">
    <xsl:attribute name="{name()}">
      <xsl:choose>
        <xsl:when test="starts-with(., '#')">
          <xsl:value-of select="concat('#', $prefix, substring-after(., '#'))"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="."/>
        </xsl:otherwise>
      </xsl:choose>  
    </xsl:attribute>
  </xsl:when>
  <xsl:when test="name()='inkscape:href'">
    <xsl:attribute name="{name()}">
      <xsl:choose>
        <xsl:when test="starts-with(., '#')">
          <xsl:value-of select="concat('#', $prefix, substring-after(., '#'))"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="."/>
        </xsl:otherwise>
      </xsl:choose>  
    </xsl:attribute>
  </xsl:when>
  <xsl:otherwise>
    <xsl:attribute name="{name()}">
          <xsl:value-of select="ink:prefixize($prefix, .)"/>
    </xsl:attribute>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="*" mode="reid">
<xsl:param name="prefix"/>
<xsl:element name="{name()}">
    <xsl:apply-templates mode="reid" select="@*">
      <xsl:with-param name="prefix" select="$prefix"/>
    </xsl:apply-templates>
    <xsl:apply-templates mode="reid" select="*|text()">
      <xsl:with-param name="prefix" select="$prefix"/>
    </xsl:apply-templates>
</xsl:element>
</xsl:template>

<xsl:template match="text()" mode="reid">
<xsl:param name="prefix"/>
<xsl:copy/>
</xsl:template>


<xsl:template match="figure">
<saxon:assign name="y" select="$y + $imageskip-before"/>

<xsl:if test="document(mediaobject/imageobject/imagedata/@fileref)/*/*[name()='defs']/*">
  <xsl:apply-templates mode="reid" select="document(mediaobject/imageobject/imagedata/@fileref)/*/*[name()='defs']">
    <xsl:with-param name="prefix" select="mediaobject/imageobject/imagedata/@fileref"/>
  </xsl:apply-templates>
</xsl:if>

<xsl:variable name="filename" select="mediaobject/imageobject/imagedata/@fileref"/>

<xsl:for-each select="document($filename)/*/*[@inkscape:groupmode='layer']/*"> 
  <xsl:variable name="old_t" select="@transform"/>
  <xsl:copy>
    <xsl:choose>
      <xsl:when test="not(name()='use')">
        <xsl:attribute name="transform"><xsl:value-of select="concat('translate(', $left-margin, ', ', $y, ')',  ' ',  $old_t)"/></xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="transform"><xsl:value-of select="concat('translate(', $left-margin, ', ', $y, ')',  ' ',  $old_t, ' translate(', -$left-margin, ', ', -$y, ')')"/></xsl:attribute>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:apply-templates mode="reid" select="@*[name()!='transform']">
      <xsl:with-param name="prefix" select="$filename"/>
    </xsl:apply-templates>
    <xsl:apply-templates mode="reid" select="*|text()">
      <xsl:with-param name="prefix" select="$filename"/>
    </xsl:apply-templates>
  </xsl:copy>
</xsl:for-each>

<xsl:variable name="current-h"><xsl:value-of select="ink-r:run(concat($ink-path, ' ', $ill-path, mediaobject/imageobject/imagedata/@fileref, ' --query-height'))"/></xsl:variable>
<xsl:message>current-h: <xsl:value-of select="$current-h"/></xsl:message>
<saxon:assign name="y" select="$y + $current-h + $imageskip-after"/>
</xsl:template>

<xsl:template match="abstract">
<xsl:apply-templates/>
<saxon:assign name="y" select="$y + $abstract-parskip"/>
</xsl:template>

</xsl:stylesheet>
